Index: drivers/serial/tsuart0.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart0.c,v
retrieving revision 1.1
retrieving revision 1.18
diff -u -r1.1 -r1.18
--- drivers/serial/tsuart0.c	16 May 2006 19:10:12 -0000	1.1
+++ drivers/serial/tsuart0.c	3 Mar 2009 16:23:32 -0000	1.18
@@ -8,6 +8,7 @@
  * This source code is hereby licensed to the Linux 2.4 kernel under the
  * GPL, and to Technologic Systems customers under the BSD license.
  *
+ * 2006-05-16:mos:fixed parity as it was backwards, some general cleanup done
  * 2006-05-12:mos:initial version completed, based on tsuart.c
  *
  */
@@ -50,7 +51,7 @@
 #define DEBUG_TXRX 128
 #define DEBUG_PARITY 256
 
-MODULE_DESCRIPTION("Technologic Systems UART serial port driver");
+MODULE_DESCRIPTION("Technologic Systems UART modular driver core");
 
 #define DELAY_TIME      HZ / 100        // 100 Hz
 #define UART_PORT_SIZE  64              // not used
@@ -75,6 +76,7 @@
 static void tsuart_stop_tx(struct uart_port *port, unsigned int tty_stop);
 static struct timer_list timer;
 static int timer_added = 0;
+static struct timer_list timer2 = { .function = NULL };
 static inline int bit_CTS(unsigned char reg_value);
 
 //-----------------------------
@@ -137,6 +139,8 @@
   *((volatile unsigned short *)port->u.membase + offset) = value;
 }
 
+static void tsuart_try_handleTx(struct tsuart_port *port);
+
 void tsuartPutMEM16_9(struct tsuart_port *port,int offset,unsigned value) {
   if (offset != 1) {
     *((volatile unsigned short *)port->u.membase + offset) = value;
@@ -144,10 +148,12 @@
     if ((value & 0xFE) == 0) {
       port->pstatus = (port->pstatus & 0xFFFF00FF) | ((value & 0xFF) << 8);
       port->pstatus &= ~PORT_STATUS_TXMSB;
-      uart_write_wakeup(&port->u);
     } else {
-      printk("***TX Rejected (sync)\n");
+      if (port->debugFlags & DEBUG_DATA) {      
+	printk("***TX Rejected (sync)\n");
+      }
     }
+    //tsuart_try_handleTx(port); // avoid stuckness
   } else {
     value += (port->pstatus & 0xFF00);
     *((volatile unsigned short *)port->u.membase + offset) = value;
@@ -172,6 +178,7 @@
 static void tsuart_handleRx(struct tsuart_port *port,int data) {
   struct tty_struct *tty;
   unsigned int ch = data;
+  int flag = 0;
 
   if (port->debugFlags & DEBUG_DATA) {
     unsigned int ttyinf = port->u.info ? (port->u.info->tty ? 3:1) : 0;
@@ -182,18 +189,35 @@
   }
   tty = port->u.info->tty;
   if (tty->flip.count >= TTY_FLIPBUF_SIZE) {
-    tty_flip_buffer_push(tty); 
+    tty->flip.tqueue.routine((void *)tty);
+    //printk("->%X ",tty->flip.char_buf_ptr);
+    if (tty->flip.count >= TTY_FLIPBUF_SIZE) {
+      printk("TSUART0 - TTY FLIP BUF FAILED!\n");
+      return;
+    }
+  }
+#ifdef TSUART_CORRECT_PARITY
+  if (port->localStatus & PORT_STATUS_PARITY) {
+    flag |= TTY_PARITY;
   }
+#endif
   if (port->rxsize > 3) {
-    tty_insert_flip_char(tty, (ch >> 24) & 0xFF, 0);
+    tty_insert_flip_char(tty, (ch >> 24) & 0xFF, flag);
   }
   if (port->rxsize > 2) {
-    tty_insert_flip_char(tty, (ch >> 16) & 0xFF, 0);
+    tty_insert_flip_char(tty, (ch >> 16) & 0xFF, flag);
   }
   if (port->rxsize > 1) {
-    tty_insert_flip_char(tty, (ch >> 8) & 0xFF, 0);
+    tty_insert_flip_char(tty, (ch >> 8) & 0xFF, flag);
+  }
+  if (tty->flip.count >= TTY_FLIPBUF_SIZE) {
+    tty->flip.tqueue.routine((void *)tty);
+    if (tty->flip.count >= TTY_FLIPBUF_SIZE) {
+      printk("TSUART0 - TTY FLIP BUF FAILED!\n");
+      return;
+    }
   }
-  tty_insert_flip_char(tty, (ch & 0xFF), 0);
+  tty_insert_flip_char(tty, (ch & 0xFF), flag);
   port->gotBytes++;
   return;
 }
@@ -211,7 +235,7 @@
 // then feed to the byte to the UART
 static void tsuart_try_handleTx(struct tsuart_port *port) {
   struct circ_buf *xmit;
-  unsigned int ch=0;
+  unsigned int ch=0,i=0;
 
   if (!port->u.info || !port->u.info->tty) {
     if (port->debugFlags & DEBUG_DATA) {
@@ -236,20 +260,29 @@
     }
   }
   xmit = &port->u.info->xmit;
-  if (uart_circ_empty(xmit) || uart_tx_stopped(&(port->u))) {
-    tsuart_stop_tx(&port->u,0);
+  if (uart_circ_empty(xmit)) { // || uart_tx_stopped(&(port->u))) {
     return;
   }
-  // handle one character
-  ch = xmit->buf[xmit->tail];
-  if (port->debugFlags & DEBUG_DATA) {
-    unsigned int ttyinf = port->u.info ? (port->u.info->tty ? 3:1) : 0;
-    printk("tsuart Tx(%d):%02X:%d\n",port->u.line,ch,ttyinf);
-  }
-  tsuart_parity_Tx(port,ch);
-  xmit->tail = (xmit->tail + 1) & (UART_XMIT_SIZE - 1);
-  port->u.icount.tx++;
-  // done handling one character
+
+  i = 0;
+  //printk("%d:%d %p\n",xmit->tail,xmit->head,&i);
+  do {
+    // handle one character
+    ch = xmit->buf[xmit->tail];
+    if (port->debugFlags & DEBUG_DATA) {
+      unsigned int ttyinf = port->u.info ? (port->u.info->tty ? 3:1) : 0;
+      printk("tsuart Tx(%d):%02X:%d\n",port->u.line,ch,ttyinf);
+    }
+    xmit->tail = (xmit->tail + 1) & (UART_XMIT_SIZE - 1);
+    port->u.icount.tx++;
+    tsuart_parity_Tx(port,ch);
+    // done handling one character
+    i++;
+    if (uart_circ_empty(xmit)) { // || uart_tx_stopped(&(port->u))) {
+      break;
+    }
+  } while (bit_TBRE(tsuartGetSTAT(port)) && i < 64);
+  //printk("%d %X\n",i,tsuartGetSTAT(port));
 
   if (uart_circ_chars_pending(xmit) < WAKEUP_CHARS) {
     uart_write_wakeup(&port->u);
@@ -262,7 +295,6 @@
   }
 }
 
-
 //----------------------------
 // Begin FPGA dependant code <
 //----------------------------
@@ -315,89 +347,6 @@
   }
 }
 
-//-----------------------------------------------------------------------
-//                                                                      /
-// /proc Routines                                                       \_
-//                                                                      /
-//                                                                      \_
-//                                                                      /
-//                                                                      \_
-//-----------------------------------------------------------------------
-/*
-  The user can set COM3 to TTL levels as follows:
-    echo "1" > /proc/device/tsuart/com3ttl
-  The user can set COM3 to RS-232 levels as follows:
-    echo "0" > /proc/device/tsuart/com3ttl
-  The user can query the current status of COM3 as follows:
-    cat /proc/device/tsuart/com3ttl
-      "0" if COM3 is at RS-232 levels
-      "1" if COM3 is at TTL levels
- */
-/*
-int procfile_read(char *buffer, 
-		  char **buffer_location, 
-		  off_t offset, 
-		  int buffer_length, 
-		  int *eof,
-		  void *data)
-{
-  if (offset > 0) {
-    *eof = 1;
-    return 0;
-  }
-  MOD_INC_USE_COUNT;
-  buffer[0] = (get_tsuart_ttl() & 64) ? '1' : '0';
-  *buffer_location = buffer;
-  *eof = 1;
-  MOD_DEC_USE_COUNT;
-
-  return 1;
-}
-
-int procfile_write(struct file *file,
-		   const char *buffer,
-		   unsigned long count,
-		   void *data) {
-  char tmp;
-
-  MOD_INC_USE_COUNT;
-  if (copy_from_user(&tmp,buffer,1)) {
-    return -EFAULT;
-  }
-  if (tmp == '1') {
-    put_tsuart_ttl(1);
-  } else if (tmp == '0') {
-    put_tsuart_ttl(0);
-  }
-  MOD_DEC_USE_COUNT;
-  return 1;
-}
-
-int procfile_init(void) {
-  struct proc_dir_entry *dir1,*file;
-
-  dir1 = proc_mkdir("driver/tsuart",NULL);
-  if (dir1 == NULL) { return -ENOMEM; }
-  
-  file = create_proc_entry("driver/tsuart/com3ttl",
-			   S_IWUSR |S_IRUSR | S_IRGRP | S_IROTH,
-			   NULL);
-  if (file == NULL) {
-    remove_proc_entry("driver/tsuart", NULL);
-    return -ENOMEM;
-  }
-  file->read_proc = procfile_read;
-  file->write_proc = procfile_write;
-  file->owner = THIS_MODULE;
-  return 0;
-}
-
-void procfile_exit(void) {
-  remove_proc_entry("driver/tsuart/com3ttl",NULL);
-  remove_proc_entry("driver/tsuart", NULL);
-}
-*/
-
 //---------------------
 // End dependant code <
 //---------------------
@@ -410,14 +359,20 @@
     data = rxdata & port->dataMask2;
     //    printk("%X (%X)\n",data,port->parity[data]);
   } else {
-    data = rxdata & port->dataMask2;
+    data = rxdata;
   }
 
   if (!port->parity || port->parity[data] == rxdata) {
+    port->localStatus &= ~PORT_STATUS_PARITY;
     return data;
   } else {
     port->u.icount.parity++;
+    port->localStatus |= ~PORT_STATUS_PARITY;
+#ifdef TSUART_CORRECT_PARITY
+    return data;
+#else
     return -1;
+#endif
   }
 }
 
@@ -434,7 +389,6 @@
       }
       port->data = tsuart_parity_Rx(port);
     }
-  } else {
   }
 
 }
@@ -471,7 +425,7 @@
 }
 
 //-----------------------------------------------------------------------
-// Interrupt Routines                                                   <
+// Interrupt Routine                                                    <
 //-----------------------------------------------------------------------
 
 static void tsuart_interrupt(int irq, void *dev_id, struct pt_regs *regs) {
@@ -552,7 +506,9 @@
   if (TSPORT(port)->debugFlags & DEBUG_INTERFACE) {  
     printk("tsuart_start_tx(%d,%d)\n",PORTNUM(port),tty_start);
   }
+  cli();
   tsuart_checkHandleTx(TSPORT(port));
+  sti();
 }
 
 static void tsuart_stop_rx(struct uart_port *port)
@@ -580,10 +536,15 @@
 
 static unsigned int tsuart_get_mctrl(struct uart_port *port)
 {
+  struct tsuart_port *p = TSPORT(port);
   unsigned int result = 0;
 
-  result |= TIOCM_CAR;  // pretend DCD is always set
-  result |= TIOCM_DSR;  // pretend DSR is always set
+  if (p->mdmctrl) {
+    result |= p->mdmctrl(p,0);
+  } else {
+    result |= TIOCM_CAR;  // pretend DCD is always set
+    result |= TIOCM_DSR;  // pretend DSR is always set
+  }
   if (bit_CTS(tsuartGetSTAT(TSPORT(port)))) {
     result |= TIOCM_CTS;
   }
@@ -602,19 +563,59 @@
     printk("tsuart_set_mctrl(%d,RTS=%d)\n",PORTNUM(port),((mctrl&TIOCM_RTS) != 0) ? 1:0);
   }
   tsuartPutSTAT(p,assign_bit_RTS(tsuartGetSTAT(p),(mctrl&TIOCM_RTS)!=0));
-  // No support for TIOCM_DTR, so ignore it
+  if (p->mdmctrl) {
+    p->mdmctrl(p,0x80000000 | mctrl);
+  } else {
+    // No support for TIOCM_DTR, so ignore it
+  }
 }
 
 static void tsuart_break_ctl(struct uart_port *port, int break_state)
 {
-  // UART does not support BREAK
+  // some UARTs do not support BREAK
+  if (break_state == -1) break_state = 1;
+  tsuartPutSTAT((struct tsuart_port *)port,assign_bit_TXBRK(tsuartGetSTAT((struct tsuart_port *)port),break_state));
   if (TSPORT(port)->debugFlags & DEBUG_INTERFACE) {
-    printk("tsuart_break_ctl(%d,%d)\n",PORTNUM(port),break_state);
+    printk("--- tsuart_break_ctl(%d,%d)\n",PORTNUM(port),break_state);
   }
 }
 
 static int started = 0;
 
+static void tsuart_mdm_timer(unsigned long data) {
+  struct tsuart_port *root = TS,*next;
+  unsigned int status, delta;
+
+  //printk("tsuart_mdm_timer()\n");
+  while (root) {
+    next = root;
+    while (next) {
+      status = tsuart_get_mctrl(&next->u);
+      delta = status ^ next->old_status;
+      next->old_status = status;
+      if (delta) {
+	if (delta & TIOCM_CAR) {
+	  //printk("tsuart_mdm_timer: DCD\n");
+	  //uart_handle_dcd_change(&next->u, status & TIOCM_CAR);
+	}
+	if (delta & TIOCM_DSR) {
+	  //printk("tsuart_mdm_timer: DSR\n");
+	  next->u.icount.dsr++;
+	}
+	if (delta & TIOCM_CTS) {
+	  //printk("tsuart_mdm_timer: CTS\n");
+	  //uart_handle_dcd_change(&next->u, status & TIOCM_CTS);
+	}
+	//wake_up_interruptible(&next->u.info->delta_msr_wait);
+      }
+      next = next->next;
+    }
+    root = root->nextd;
+  }
+  timer2.expires = jiffies + HZ;
+  add_timer (&timer2);
+}
+
 static void tsuart_cts_timer(unsigned long data) {
   //  struct uart_port *port = (struct uart_port *)(tsuart_ports);
   //  struct uart_port *port = (struct uart_port *)data;
@@ -656,6 +657,7 @@
   TSPORT(port)->localStatus |= PORT_STATUS_OPEN;
 
   setMODE9(port,TSPORT(port)->rxsize > 1 || (TSPORT(port)->localStatus & PORT_STATUS_8PLUS1));
+  TSPORT(port)->old_status = tsuart_get_mctrl(port);
   if (started++) { // not needed?
     return 0;
   }
@@ -664,6 +666,17 @@
   timer.data = (unsigned long )port;
   timer.function = tsuart_cts_timer;
 
+  if (timer2.function == NULL) {
+    if (TSPORT(port)->debugFlags & DEBUG_INTERRUPT) {
+      printk("Starting MDM timer\n");
+    }
+    timer.expires = jiffies + HZ;
+    timer2.function = tsuart_mdm_timer;
+    add_timer(&timer2);
+  } else {
+    printk("MDM timer can't start!\n");
+  }
+
 #if 0
   for (i=0;i<256;i++) {
     stats[i] = 0;
@@ -697,6 +710,10 @@
     del_timer (&timer);
     timer_added = 0;
   }
+  if (timer2.function) {
+    del_timer(&timer2);
+    timer2.function = NULL;
+  }
 
 #if 0
   for (i=0;i<6;i++) {
@@ -705,6 +722,8 @@
 #endif
 
   tsuartPutSTAT(p,assign_bits_BAUD(tsuartGetSTAT(p),0));
+  port->info->xmit.tail = port->info->xmit.head; // avoid stuckness
+
 }
 
 static int calcpar(int val,int parodd) {
@@ -797,7 +816,7 @@
 static void tsuart_change_speed(struct uart_port *port, unsigned int cflag, unsigned int iflag, unsigned int quot)
 {
   struct tsuart_port *p = TSPORT(port);
-  int encoded_baud,baud,par=0,parodd=0,dbits=8,stop=0;
+  int encoded_baud,baud,par=0,parodd=0,dbits=8; // ,stop=0;
 
   if (TSPORT(port)->debugFlags & DEBUG_INTERFACE) {
     printk("tsuart_change_speed(%d,%d,%d,%d)\n",PORTNUM(port),cflag,iflag,quot);
@@ -851,7 +870,9 @@
   */
   TSPORT(port)->dataMask2 = (1 << (dbits)) - 1;
   // TO DO: only allow this on an 8-bit port!
-  if (dbits == 8 && par) {
+  if (TSPORT(port)->rxsize > 1) {
+    TSPORT(port)->dataMask2 = 0x1FF;
+  } else if (dbits == 8 && par) {
     TSPORT(port)->localStatus |= PORT_STATUS_8PLUS1;
     TSPORT(port)->dataMask = 0x1FF;
   } else {
@@ -863,7 +884,11 @@
   if (cflag & CSTOPB) {
     printk("tsuart:unsupported stop bits, using 1\n");
   }
-  initpar(TSPORT(port),dbits,par,parodd);  
+  if (TSPORT(port)->rxsize < 2) {
+    initpar(TSPORT(port),dbits,par,parodd);  
+  }
+  // clear the receive FIFO
+  while (bit_DR(tsuartGetSTAT(p))) tsuartGetDATA(p);
 }
 
 static const char *tsuart_type(struct uart_port *port)
@@ -896,13 +921,16 @@
     if (port->membase == 0) {
       port->membase = (void *) __ioremap(port->mapbase & 0xFFFFF000, 4096,0)
 	+ (port->mapbase & 0xFFF);
-      //      printk("port %p:mapbase=%X, membase=%X\n",port,port->mapbase,port->membase);
-      if (!port->membase) {
+      //printk("port %p:mapbase=%X, membase=%X\n",port,port->mapbase,port->membase);
+      if (port->membase == (void *)(port->mapbase & 0xFFF)) {
+	port->membase = 0;
 	printk(KERN_ERR "tsuart: cannot map io memory\n");
 	return -ENOMEM;
       }
     }
   }
+  // clear the receive FIFO
+  while (bit_DR(tsuartGetSTAT(TSPORT(port)))) tsuartGetDATA(TSPORT(port));
   return 0;
 }
 
@@ -932,6 +960,9 @@
     ret = -EINVAL;
   if (ser->irq < 0 || ser->irq >= NR_IRQS)
     ret = -EINVAL;
+  if (ser->baud_base < 9600) {
+    ser->baud_base = 115200; // required to allow ioctl to set low_latency
+  }
   //  if (ser->baud_base != 115200)
   //    ret = -EINVAL;
   if (TSPORT(port)->debugFlags & DEBUG_INTERFACE) {
@@ -979,12 +1010,7 @@
 	.verify_port	= tsuart_verify_port,
 	.ioctl		= tsuart_ioctls,
 };
-/*
-static struct tty_driver normal, callout;
-static struct tty_struct *cs_tsuart_table[UART_NR];
-static struct termios *cs_tsuart_termios[UART_NR], 
-			*cs_tsuart_termios_locked[UART_NR];
-			*/
+
 static inline char *kstrcat(char *src,char *src2) {
   char *dst;
 
@@ -1079,103 +1105,7 @@
 #define CUA_NAME CALLOUT_TSUART_NAME
 
 
-/*
-  
- */
 static struct uart_driver tsuart_reg;
-/* , tsuart_reg2 = {
-	.owner			= THIS_MODULE,
-	.normal_major		= SERIAL_TSUART_MAJOR,
-#ifdef CONFIG_DEVFS_FS
-	.normal_name		= SERIAL_TSUART_NAME "%d",
-	.callout_name		= CALLOUT_TSUART_NAME "%d",
-#else
-	.normal_name		= SERIAL_TSUART_NAME,
-	.callout_name		= CALLOUT_TSUART_NAME,
-#endif
-	.normal_driver		= &normal,
-	.callout_major		= CALLOUT_TSUART_MAJOR,
-	.callout_driver		= &callout,
-	.table			= cs_tsuart_table,
-	.termios		= cs_tsuart_termios,
-	.termios_locked	        = cs_tsuart_termios_locked,
-	.minor			= SERIAL_TSUART_MINOR,
-	.nr			= UART_NR,
-	.cons			= NULL,
-};
-*/
-/*
-  Two strategies for detecting ports:
-  1. Each known model has a "profile" which is a set of values for the
-     port parameters.  Known models include:
-     TS7260 - 1 or 3 ports, TTL support on some of them
-     TS7300 - 8 ports, 9-bit supported
-     TS5500 - 2 ports (1 1/2), limited baud rates
-     BAT3   - 1 port in one of 4 I/O locations
-  So if we aren't given any parameters, we should try to auto-detect by
-  seeing if we can identify our board as one of the above known boards,
-  and if not we don't load.  If we are given parameters then we simply
-  use those.
-  2. Once we have the list of possible ports, we need to go through them
-  to try to find what actual ports exist.  On all boards we should be able
-  to sanity check the STAT port, and on some boards we might be able to
-  read another port to get a signature value.  If a port has the force
-  flag set, then we assume the information given is correct, and don't
-  try to sanity check that the port is really there.
-  3. For each port we determine is actually there, we need to allocate
-  a struct uart_driver instance and populate it with the information for
-  that port.  Then we register the port.
-  4. The driver is composed of several parts:
-  - general serial port functionality (OS specific code)
-    this code is responsible for providing the OS interface functions,
-    and for the logic sending and receiving bytes (two sections).
-  - register access code
-    this code defines the registers on the board and a hardware independant
-    method to access them. it also defines the bit-fields on the board
-  - hardware specific code
-    this code defines various code which is specific to various boards,
-    including code to determine what kind of board we are running on.
-
-  Shouldn't do any WRITES unless we are reasonably sure we have our UART.
-  For most of our configurations, we can detect where the UARTs are
-  supposed to be.
-  To detect the BAT3 board, read the ID register at 0x100, 0x110, 0x200,
-  and 0x210.  When we see 0x28 we know we have probably found a BAT3 board,
-  and can then sanity check the board.  But our existing mechanism isn't
-  suitable because we peform writes to probe for the board.
-
-  Here is a new idea.  The core driver should only have the following:
-  knowledge of the STAT and DATA register, and the interface between
-  the serial port(s) and the operating system
-  Then we can write modules for particular boards which determine whether
-  or not we have that board, and if so, communicates with the core driver
-  to create the appropriate serial ports for that board.
-  I think we can have a single core module handling all the serial ports
-  that exist.  The key point is that the individual ports are allocated
-  individually.  This requires that the interrupt routine and possibly
-  the timer routine are able to determine which port structure they were 
-  called with, or more generally, which ports they should handle, since
-  we might want to handle all ports for a given interrupt.  One way to
-  do this might be to create our own extended port info structure which
-  has a pointer to the next port in the chain.  This would also allow us
-  to stop relying on the stupid "unused" variable in struct uart_port.
-
-  It looks like struct uart_port *port = dev_id.
-
-  NOTE:
-  1. What if we try to register a port that is already registered?
-     - We should check for a disallow that! DONE!
-  2. How do we unregister a port if we've already unloaded the module that
-     did the registering?
-     - We could unregister all ports by unloading the base module
-     - We could unregister ports on module load if we detect they are already
-       loaded.  This assumes all ports for a module are either loaded or not,
-       otherwise we might wind up loading some and unloading others.
-  3. Shouldn't the tsuart_reg.nr field reflect the current number of registered
-     ports?
-  4. The cs_tsuart_* arrays, how do we keep the up to date with the correct
-     number of elements?  Who uses these?
- */
 
 typedef int (*portCompF)(struct tsuart_port *,struct tsuart_port *);
 
@@ -1224,6 +1154,38 @@
 }
 */
 
+inline int shares(struct tsuart_port *port) {
+  return (port->localStatus & PORT_STATUS_SHIRQ) == PORT_STATUS_SHIRQ;
+}
+
+static int irqConflict(struct tsuart_port *port) {
+  struct tsuart_port *next;
+
+  if (!TS) {
+    return 0;
+  }
+  next = TS;
+  while (next) {
+    if (next->u.irq == port->u.irq) {
+      // allow only if all ports already registered are either
+      // 1. the same boardId as the new port or
+      // 2. allowing sharing, and the new port allows sharing
+      while (next) {
+	if (next->boardId == port->boardId) {
+	  return 0;
+	}
+	if (!shares(port) || !shares(next)) {
+	  return 1;
+	}
+	next = next->nextd;
+      }
+      return 0;
+    }
+    next = next->next;
+  }
+  return 0;
+}
+
 // Returns TRUE if an IRQ is already allocated for the given port
 static int addPort(struct tsuart_port *port) {
   struct tsuart_port *next;
@@ -1260,10 +1222,10 @@
   stat = tsuartGetSTAT(port);
   tsuartPutSTAT(port,(stat & 0xFF) | 0xEF);
   stat2 = tsuartGetSTAT(port);
-  if (portDebug & DEBUG_PROBE) {
+  if (port->debugFlags & DEBUG_PROBE) {
     printk("STAT probe: %X %X\n",stat,stat2);
   }
-  tsuartPutSTAT(port,0);
+  tsuartPutSTAT(port,stat);
   return ((stat & 0x1F) == (stat2 & 0x1F) && (stat2 & 0xE0) == 0xE0);
 }
 
@@ -1288,6 +1250,10 @@
     return -1;
   }
   port->driver = driver;
+  if (irqConflict(port)) {
+    printk("IRQ in use\n");
+    return -1;
+  }
   if (portExists(port)) {
     printk("Port already registered\n");
     return -1;
@@ -1296,11 +1262,14 @@
   port->u.line = d->lines;
   state = driver->state + port->u.line;
   if ((ret = uart_add_one_port(driver,p)) == 0) {
-    if (portDebug & DEBUG_ENDS) {
+    if (port->debugFlags & DEBUG_ENDS) {
       printk("registered port %p\n",port);
     }    
     if (!addPort(port)) {		
-      ret=request_irq(port->u.irq, tsuart_interrupt, 0, "tsuart_uarts", p);
+      ret=request_irq(port->u.irq, tsuart_interrupt, 
+		      port->localStatus & PORT_STATUS_SHIRQ ?
+		      SA_SHIRQ : 0, 
+		      "tsuart_uarts", p);
       if (ret != 0) {
 	printk("Unable to allocate irq %d\n",port->u.irq);
       } else {
@@ -1314,7 +1283,7 @@
 	}
     }
   } else {
-    if (portDebug & DEBUG_ENDS) {
+    if (port->debugFlags & DEBUG_ENDS) {
       printk("Failed to register port %p with driver %p, ret=%d\n",port,driver,ret);
     }
     return -1;
@@ -1323,12 +1292,19 @@
     d->lines++;
 
     if (!tsuart_sanity_check_STAT(port)) {
-      printk("WARNING: port %p failed STAT sanity check!\n",port);
+      printk("WARNING: port %d failed STAT sanity check!\n",port->u.line);
+      // Note: This will fail in a number of cases which are fatal:
+      // 1. If the FPGA bitstream isn't loaded 
+      // 2. We are loaded on hardware that doesn't have a TS-UART present (e.g. wrong arch)
+      // It will also fail in a number of cases which are benign:
+      // 1. Loopback is installed on the flow control lines (e.g. RTS/CTS)
+      // 2. We are a specialized TS-UART that doesn't have all the bits in STAT defined
     }
   }
   return ret;
 }
 
+/*
 int tsuart_unregister_port(struct tsuart_port *port) {
   struct tsuart_port *next;
 
@@ -1364,20 +1340,14 @@
   // TO DO: we are responsible for kfree()'ing port
   return -1;
 }
+*/
 
 static int __init tsuart_init(void)
 {
-  int ret=0;
-  
   tsuart_configure_driver(&tsuart_reg,SERIAL_TSUART_MAJOR,SERIAL_TSUART_MINOR,
                           TTY_NAME,CUA_NAME,64);
   
-  //  ret = uart_register_driver(&tsuart_reg);
-  if (ret) {
-    return ret;
-  }
-  //	ret = procfile_init();
-  return ret;
+  return 0;
 }
 
 static void __exit tsuart_exit(void)
@@ -1406,7 +1376,6 @@
       kfree(tmp);
     } while (next); 
   }
-  //	procfile_exit();
   //  printk("unregistering drivers\n");
   while (drivers) {
     if (drivers->car) {
@@ -1428,7 +1397,7 @@
 module_exit(tsuart_exit);
 
 EXPORT_SYMBOL(tsuart_register_port);
-EXPORT_SYMBOL(tsuart_unregister_port);
+//EXPORT_SYMBOL(tsuart_unregister_port);
 EXPORT_SYMBOL(tsuartGetIO8);
 EXPORT_SYMBOL(tsuartGetMEM8);
 EXPORT_SYMBOL(tsuartGetMEM16);
@@ -1446,5 +1415,5 @@
 
   When the TS-UART is re-used in a new board design, it is only necessary
   to write a loader driver.  In most cases all the loader driver does is
-  probe for ports it knows about
+  probe for ports it knows about.
  */
Index: drivers/serial/tsuart7260.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart7260.c,v
retrieving revision 1.1
retrieving revision 1.6
diff -u -r1.1 -r1.6
--- drivers/serial/tsuart7260.c	16 May 2006 19:12:17 -0000	1.1
+++ drivers/serial/tsuart7260.c	29 Sep 2008 16:15:47 -0000	1.6
@@ -35,6 +35,10 @@
 
 #define TS_TTL_REG   0x2000000
 
+static inline int get_tsuart_TRI(void) {
+  return ((inw(TS7XXX_IO16_BASE + 0x2400000) & 1) == 1);
+}
+
 static inline int get_tsuart_ttl(void) {
   unsigned char c;
   c = inb(TS7XXX_IO8_BASE + TS_TTL_REG);
@@ -133,6 +137,7 @@
   remove_proc_entry("driver/tsuart", NULL);
 }
 
+#define BOARD_ID_7260 0x7260
 static int tryInitPort(int base) {
   struct tsuart_port *ts;
 
@@ -146,9 +151,12 @@
   ts->u.iotype = SERIAL_IO_MEM;
   ts->get = tsuartGetMEM8;
   ts->put = tsuartPutMEM8;
+  ts->mdmctrl = 0;
   ts->debugFlags = portDebug;
   ts->u.mapbase = /*0 x72000000 + */ base;
   ts->u.irq = 32;
+  ts->localStatus |= PORT_STATUS_SHIRQ;
+  ts->boardId = BOARD_ID_7260;
 
   if (tsuart_register_port(0,ts) != 0) {
     return 0;
@@ -165,22 +173,26 @@
     printk("TS-UART/7260 did not detect a TS-7260 board\n");
     return -1;
   } else {
-    printk("TS-UART/7300 detected a TS-7260 board\n");
+    printk("TS-UART/7260 detected a TS-7260 board\n");
   }
   ret = procfile_init();
   if (ret) {
     return ret;
   }
 
+  cli(); // bug fix for second uart always being on at startup
   if (tryInitPort(0x12400000)) {
     ports++;
   }
-  if (tryInitPort(0x13000000)) {
-    ports++;
-  }
-  if (tryInitPort(0x13400000)) {
-    ports++;
+  if (get_tsuart_TRI()) {
+	  if (tryInitPort(0x13000000)) {
+	    ports++;
+	  }
+	  if (tryInitPort(0x13400000)) {
+	    ports++;
+	  }
   }
+  sti();
   return (ports > 0) ? 0 : -1;
 }
 
